package ca.uwaterloo.cs.jgrok.env;

import java.io.File;
import org.xml.sax.Attributes;

public class EnvLoader extends DefaultLoader {
    
    public EnvLoader() {}
    
    public void startElement(String uri, String name, String qName, Attributes atts) {
        String elemName = null;
        String elemFile = null;
        String elemLoader = null;
        
        if (name.equalsIgnoreCase("Element")) {
            for(int i = 0; i < atts.getLength(); i++) {
                String localName = atts.getLocalName(i);
                
                if(localName.equalsIgnoreCase("Name"))
                    elemName = atts.getValue(i);
                else if(localName.equalsIgnoreCase("File"))
                    elemFile = atts.getValue(i);
                else if(localName.equalsIgnoreCase("Loader"))
                    elemLoader = atts.getValue(i);
            }
            
            String fullFileName = new File(this.fileName).getParent() + File.separator + elemFile;
            load(elemName, fullFileName, elemLoader);
        }
    }
    
    private void load(String elemName, String fileName, String loaderName) {
        Tracing trc = env.getTracing();
        
        try {
            if(trc.isEnabled()) {
                trc.out.println("Loading " + elemName + " " + fileName + " ...");
            }
            
            Class<? extends Loader> defClass;
            defClass = Class.forName(loaderName).asSubclass(Loader.class);
            Loader loader = defClass.newInstance();
            loader.load(env, fileName);
        } catch(Exception e) {
           e.printStackTrace(env.err);
           
           env.err.println("Loading " + elemName + " " + fileName + " falied!");
           env.err.println("\tLoader=" + loaderName);
        }
    }
}
