package ca.uwaterloo.cs.jgrok.lib;

import ca.uwaterloo.cs.jgrok.env.Env;
import ca.uwaterloo.cs.jgrok.fb.*;
import ca.uwaterloo.cs.jgrok.interp.Value;

/**
 * <pre>
 *     EdgeSet closure(EdgeSet edgeSet);
 *     EdgeSet unclosure(EdgeSet edgeSet);
 * </pre>
 */
public class Closure extends Function {
    
    public Closure() {
        name = "closure";
        type = EdgeSet.class;
        paramTypes = new Class[1];
        paramTypes[0] = EdgeSet.class;
    }
    
    public Value invoke(Env env, Value[] vals)
        throws InvocationException {
        EdgeSet eset = (EdgeSet)vals[0].objectValue();
        if(getName().equals("unclosure")) {
            return new Value(AlgebraOperation.unclosure(eset));
        } else if(getName().equals("closure")) {
            return new Value(AlgebraOperation.transitiveClosure(eset));
        } else {
            throw InvocationException.createUnknownFunction(getName());
        }
    }
}
