package ca.uwaterloo.cs.jgrok.lib;

import ca.uwaterloo.cs.jgrok.env.Env;
import ca.uwaterloo.cs.jgrok.fb.*;
import ca.uwaterloo.cs.jgrok.interp.*;

/**
 * int sgcount(EdgeSet)
 */
public class GraphPartitionCount extends Function {
    
    public GraphPartitionCount() {
        name = "sgcount";
        type = int.class;
        paramTypes = new Class[1];
        paramTypes[0] = EdgeSet.class;
    }
    
    public Value invoke(Env env, Value[] vals)
        throws InvocationException {
        EdgeSet rel = (EdgeSet)vals[0].objectValue();
        Partition p = new Partition();
        int count = p.countPartitions(rel);
        return new Value(count);
    }
}
