package ca.uwaterloo.cs.jgrok.lib;

import ca.uwaterloo.cs.jgrok.env.Env;
import ca.uwaterloo.cs.jgrok.fb.NodeSet;
import ca.uwaterloo.cs.jgrok.interp.*;

/**
 * <pre>
 *     NodeSet range(int num1, int num2)
 *     NodeSet range(int num1, int num2, int step)
 * </pre>
 */
public class Range extends Function {
    
    public Range() {
        name = "range";
        type = NodeSet.class;
        paramTypes = new Class[2];
        paramTypes[0] = int.class;
        paramTypes[1] = int.class;
    }
    
    public Value invoke(Env env, Value[] vals)
        throws InvocationException {
        int a = vals[0].intValue();
        int b = vals[1].intValue();
        int incr = 1;
        
        NodeSet set = new NodeSet();
        
        if(vals.length == 3) {
            incr = vals[2].intValue();
            if(incr < 1)
                throw new InvocationException("range step less than 1");
        }
        
        if(a < b) {
            for(int i = a; i <= b; i = i+incr) {
                set.add(i+"");  //??? UGLY CODE INDEED!
            }
        } else {
            for(int i = a; i >= b; i= i-incr) {
                set.add(i+"");  //??? UGLY CODE INDEED!
            }
        }
        
        return new Value(set);
    }
}
