package ca.uwaterloo.cs.jgrok.lib;

import ca.uwaterloo.cs.jgrok.env.Env;
import ca.uwaterloo.cs.jgrok.interp.Value;

/**
 * void echo(boolean)
 * void timing(boolean)
 */
public class ScriptingOption extends Function {
    
    public ScriptingOption() {
        name = "echo";
        type = void.class;
        paramTypes = new Class[1];
        paramTypes[0] = boolean.class;
    }
    
    public Value invoke(Env env, Value[] vals)
        throws InvocationException {
        boolean b = vals[0].booleanValue();
        
        if(getName().equals("echo")) {
            env.traceScriptUnit().getOption().setEchoOn(b);
        } else if(getName().equals("timing")) {
            env.traceScriptUnit().getOption().setTimeOn(b);
        } else {
            throw InvocationException.createUnknownFunction(getName());
        }
        
        return Value.VOID;
    }
}
