package ca.uwaterloo.cs.jgrok.lib;

import ca.uwaterloo.cs.jgrok.env.Env;
import ca.uwaterloo.cs.jgrok.fb.*;
import ca.uwaterloo.cs.jgrok.interp.*;
import ca.uwaterloo.cs.jgrok.util.SimRank;

/**
 * TupleSet sim(EdgeSet graph)
 * TupleSet sim(EdgeSet graph, int iterationCount)
 */
public class SimRankGraph extends Function {
    
    public SimRankGraph() {
        name = "sim";
        type = TupleSet.class;
        paramTypes = new Class[1];
        paramTypes[0] = EdgeSet.class;
    }
    
    public Value invoke(Env env, Value[] vals)
        throws InvocationException {
        EdgeSet graph;
        SimRank simRank;
        
        graph = (EdgeSet)vals[0].objectValue();
        if(name.equals("simIn"))
            graph = AlgebraOperation.inverse(graph);
        simRank = new SimRank(graph);
        
        int iterationCount = 10;
        if(vals.length == 2) iterationCount = vals[1].intValue();
        return new Value(simRank.compute(iterationCount));
    }
}
