package ca.uwaterloo.cs.jgrok.lib;

import ca.uwaterloo.cs.jgrok.env.Env;
import ca.uwaterloo.cs.jgrok.fb.*;
import ca.uwaterloo.cs.jgrok.interp.Value;

/**
 * <pre>
 *     tset tail(tset)
 *     tset tail(tset, int)
 * </pre>
 */
public class Tail extends Function {
    
    public Tail() {
        name = "tail";
        type = TupleSet.class;
        paramTypes = new Class[1];
        paramTypes[0] = TupleSet.class;
    }
    
    public Value invoke(Env env, Value[] vals)
        throws InvocationException {
        int count;
        int start;
        TupleSet input;
        TupleSet output;
        TupleList tList;
        
        input = (TupleSet)vals[0].objectValue();
        tList = input.getTupleList();
        
        if(vals.length == 1) count = 10;
        else count = vals[1].intValue();
        
        start = tList.size() - count;
        start = (start > 0) ? start : 0;
        
        output = input.newSet();        
        for(int i = start; i < tList.size(); i++) {
            output.add((Tuple)tList.get(i).clone());
        }
        
        return new Value(output);
    }
}
