package ca.uwaterloo.cs.jgrok.lib.math;

import ca.uwaterloo.cs.jgrok.env.Env;
import ca.uwaterloo.cs.jgrok.interp.*;
import ca.uwaterloo.cs.jgrok.lib.Function;
import ca.uwaterloo.cs.jgrok.lib.InvocationException;

/**
 * Function sqrt
 * <pre>
 *     float sqrt(int);
 *     float sqrt(float);
 * </pre>
 * 
 * @author JingweiWu
 */
public class Sqrt extends Function {

    public Sqrt() {
        name = "sqrt";
        type = float.class;
        paramTypes = new Class[1];
        paramTypes[0] = int.class;
    }
    
    public Value invoke(Env env, Value[] vals)
        throws InvocationException {
        
        try {
            double param = (double)vals[0].floatValue();
            return new Value((float)Math.sqrt(param));
        } catch(Exception e) {
            throw new InvocationException(e.getMessage());
        }
    }
}
